var express    = require('express');
var exec       = require('child_process').exec;		

function backendClean(fileName){
	
	return new Promise((resolve,reject)=>{
		exec('cd explorviz-ui-backend/plugins/net/explorviz/ && rm -rf plugins/*', (error, stdout,stderr)=>{

			if (error) {
				reject(error);
				return;
			}

			console.log(stdout);
			console.log(stderr);

			resolve(fileName);

		})
	})
}

function backendPull(fileName){
	
	return new Promise((resolve, reject)=> {

		exec('cd ' + fileName + ' git pull ', (error, stdout, stderr) => {

			if (error) {
				reject(error);
				return;
			}

			console.log(stdout);
			console.log(stderr);

			resolve();

		}); 
	})

}

function backendInstallAddons(checkedFiles,downloadFiles){

	return new Promise((resolve, reject)=>{
		checkedPlugins = checkedFiles.filter(function(file){
			return /\bexplorviz-backend-plugin-\w*/.exec(file);
		});

		if(checkedPlugins.length !== 0 ){

			checkedPlugins.forEach((pluginName) => {
						exec('cd '+ pluginName + ' git pull ' + '&& rsync -av . ' + ' ../explorviz-ui-backend/plugins/net/explorviz/plugins/ ' + ' --exclude .git', (error, stdout, stderr) => { //'cd explorviz-ui-backend/plugins/net/explorviz/plugins/ ' + 
							
							if (error) {
								reject(error);
								return;
							}

							console.log(stdout);
							console.log(stderr);
							
							resolve();

						});

					})
		} else {
			resolve();
		}

	})


}
function backendBuild(fileName){
	
	return new Promise((resolve,reject)=>{
		exec('cd '+ fileName + ' && mvn compile war:war ', (error,stdout,stderr)=> {
			if (error) {
				reject(error);
				return;
			}

			console.log(stdout);
			console.log(stderr);
			resolve({zipFileName:'backend.war', path:'explorviz-ui-backend/target/explorviz-ui-backend-1.0-SNAPSHOT.war'});


		})

	})


}

module.exports = {
	backendClean,
	backendPull,
	backendInstallAddons,
	backendBuild


}